SystemOrganization addCategory: #'Seaside-Widgets-Components'!
SystemOrganization addCategory: #'Seaside-Widgets-Decorations'!

WAFileLibrary subclass: #WANavigationFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WANavigationFiles commentStamp: 'jf 1/11/2009 19:15' prior: 0!
Provides CSS to render WANavigation using tabs.!

!WANavigationFiles methodsFor: 'styles' stamp: 'lr 1/7/2009 13:58'!
mainCss
	^' /* this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/ */
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}


.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
	line-height: 1.1;  /* IE6 CSS workaround - http://www.dracos.co.uk/web/css/ie6floatbug/ */
}

/* customization */
.kalsey .navigation-content tbody tr th, .kalsey .navigation-content tfoot tr th {
	text-align: right;
	vertical-align: top;
}

.kalsey .navigation-content h2 {
	font-size: 1.2em;
}

.kalsey .navigation-content tbody.right tr td, .kalsey .navigation-content tfoot.right tr td {
	text-align: right;
}

'! !

!WANavigationFiles methodsFor: 'accessing' stamp: 'pmm 10/29/2008 12:09'!
selectorsToInclude
	^#(mainCss)! !

!GRPackage class methodsFor: '*seaside-widgets' stamp: 'lr 2/17/2010 15:14'!
seasideWidgets
	^ self new
		name: 'Seaside-Widgets';
		description: 'Various sample Decorations and Components that require Canvas.';
		addDependency: 'Seaside-Canvas';
		addDependency: 'Seaside-Component';
		url: #seasideUrl;
		yourself! !

WANotification subclass: #WAValidationNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WAValidationNotification commentStamp: 'cds 7/25/2005 10:17' prior: 0!
I am signaled to indicate that a validation has occurred.  See: Object>>validationError:, WAComponent>>validateWith: and WAValidationDecoration.!

WAComponent subclass: #WACanvasWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WACanvasWidget commentStamp: 'jf 9/4/2009 15:54' prior: 0!
A common superclass for all widgets that want to use WARenderCanvas as their renderer.!

WACanvasWidget subclass: #WAAlphabeticBatchedList
	instanceVariableNames: 'items currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAAlphabeticBatchedList commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WAAlphabeticBatchedList organizes a collection of items into pages for display. A page contains all items whose string representation (item displayString) starts with the same character. WAAlphabeticBatchedList only displays the navigation (alphabet with links) for the list. Your code needs to display the current page.

Use WAAlphabeticBatchedList>>items: to set the collections of items.
Use WAAlphabeticBatchedList>>batch to get the items to display on the current page

See WABatchTest for example of usage.
Select "Batch" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	currentPage	<Character>	the character of the curent page
	items	<(Collection of: (Object ))> collection of the items managed by WAAlphabeticBatchedList. Collection is sorted before items are displayed.
!

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'lr 1/23/2010 13:27'!
allPages
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'jf 9/30/2009 01:10'!
batch
	^ items select: [ :each | each greaseString asUppercase first = self currentPage ]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
currentPage
	^ currentPage ifNil: [currentPage := self validPages first]! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:16'!
currentPage: aCharacter
	currentPage := aCharacter! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnFirstPage
	^ self validPages first = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'testing' stamp: 'avi 12/18/2004 18:21'!
isOnLastPage
	^ self validPages last = self currentPage! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:13'!
items
	^ items! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'avi 12/18/2004 18:20'!
items: aCollection
	items := aCollection! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'avi 12/18/2004 18:19'!
nextPage
	self isOnLastPage ifFalse: [currentPage := self validPages after: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
previousPage
	self isOnFirstPage ifFalse: [currentPage := self validPages before: currentPage]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 3/4/2009 12:15'!
renderContentOn: html
	items isEmpty
		ifTrue: [ ^ self ].
	html div
		class: 'batch';
		with: [
			self renderPreviousOn: html.
			self renderPagesOn: html.
			self renderNextOn: html ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:15'!
renderPagesOn: html
	self allPages
		do: [ :char |
			currentPage = char
				ifFalse: [
					(self validPages includes: char)
						ifTrue: [ html anchor callback: [self currentPage: char]; with: char]
						ifFalse: [ html text: char ] ]
				ifTrue: [ html strong: char ] ]
		separatedBy: [ html space ]! !

!WAAlphabeticBatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WAAlphabeticBatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WAAlphabeticBatchedList methodsFor: 'accessing-calculated' stamp: 'jf 2/15/2010 23:37'!
validPages
	^ (items collect: [ :each | each greaseString asUppercase first ]) asSet sorted! !

WACanvasWidget subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WABatchSelection commentStamp: 'rew 9/24/2007 20:22' prior: 0!
WABatchSelection displays a list of objects. The list is show N (currently 8) items per page, with links to navigate to other pages if needed. Objects in the list must implement one method that returns text description of the item and one method that returns a name or label used as the link users click to select the item. The text description is displayed below the link.

Example
	items := OrderedCollection new.
	1 to: 20 do: [:each | items add: (Contact new name: each; phoneNumber: '54321';yourself)].
	selection := WABatchSelection items: items link: #name text: #phoneNumber.
	result := self call: selection.

	where the Contact class has methodsinstance vars "phoneNumber" and "name", with
	setter & getter methods.

Instance Variables:
	batcher	<WABatchedList>	description of batcher
	linkSelector	<Symbol>	method sent to items in list for link text
	textSelector	<Symbol>	method sent to items in list for text description

!

!WABatchSelection class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:39'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:35'!
batchSize
    ^batcher batchSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:34'!
batchSize: aSize
    batcher batchSize: aSize! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'commands' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
items: aCollection
	batcher := WABatchedList new
		items: aCollection;
		batchSize: 8;
		yourself! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector := aSymbol! !

!WABatchSelection methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html unorderedList: [
		batcher batch do: [ :each |
			html anchor
				callback: [ self choose: each ];
				with: (each perform: linkSelector).
			html break.
			html text: (each perform: textSelector).
			html paragraph ] ].
	html div
		style: 'text-align: center';
		with: batcher! !

!WABatchSelection methodsFor: 'accessing' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector := aSymbol! !

WACanvasWidget subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WABatchedList commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WABatchedList helps display a collection of items across multiple pages. WABatchedList organizes a collection into pages (or batches) of batchSize items each and renders navigation links for a user to moved between pages. WABatchedList>>batch returns the items to display in the current page or batch. Your code has to display the items.

See WABatchSelection for example of usage.

Instance Variables:
	batchSize	<Integer>	number of items to display on a single page
	currentPage	<Integer>	 index of current page, starts a 1
	items	<SequenceableCollection of Objects>	objects organized into pages for display

!

!WABatchedList class methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		items: (1 to: 100);
		yourself! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
batch
	^ self items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize := aNumber! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage := aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
endIndex
	^ self currentPage * self batchSize min: self items size! !

!WABatchedList methodsFor: 'initialization' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	self batchSize: 10.
	self currentPage: 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnFirstPage
	^ self currentPage = 1! !

!WABatchedList methodsFor: 'testing' stamp: 'rjl 8/9/2006 14:32'!
isOnLastPage
	^ self currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items := aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
maxPages
	^ (self items size / self batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
nextPage
	self isOnLastPage ifFalse: [self currentPage: self currentPage + 1]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'actions' stamp: 'rjl 8/9/2006 14:31'!
previousPage
	self isOnFirstPage ifFalse: [self currentPage: self currentPage - 1]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 3/4/2009 12:16'!
renderContentOn: html
	self maxPages = 0
		ifTrue: [ ^ self ].
	html div
		class: 'batch';
		with: [
			self renderPreviousOn: html.
			self renderPagesOn: html.
			self renderNextOn: html ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchor callback: [ self nextPage ]; with: '>>' ]
		ifTrue: [ html text: '>>' ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'al 9/7/2006 17:07'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			self currentPage = index
				ifFalse: [html anchor callback: [self currentPage: index]; with: index]
				ifTrue: [html strong: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchor callback: [ self previousPage ]; with: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'rjl 8/9/2006 14:30'!
startIndex
	^ (self currentPage - 1) * self batchSize + 1! !

!WABatchedList methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:55'!
states
	^ Array with: self! !

!WACanvasWidget methodsFor: 'rendering' stamp: 'jf 9/4/2009 16:07'!
rendererClass
	"Make sure we use WARenderCanvas even if a different renderer is default."
	^ WARenderCanvas! !

WACanvasWidget subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WADateSelector commentStamp: 'rew 1/23/2008 21:10' prior: 0!
WADateSelector displays dropdown menus (html select) allowing a user to delect a date within a range. "startYear" and "endYear" define the range of selectable dates. Date displayed in month, day, year format. WADateSelector>>date returns date user selected as a Date object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	day	<Integer 1-31> selected day
	endYear	<Integer>	end of range of dates user is allowed to select, not required to use 4 digits
	month	<Integer 1-12>	selected month
	startYear	<Integer>	 start of range of dates user is allowed to select, not required to use 4 digits
	year	<Integer>	selected year

!

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/22/2006 08:02'!
date
	(self privateIsValidDay: day monthNumber: month year: year)
		ifFalse: [self error: 'Invalid date'].
	^ self dateClass year: year month: month day: day! !

!WADateSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	day := aDate dayOfMonth.
	month := aDate monthIndex.
	year := aDate year! !

!WADateSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:59'!
dateClass
	^ Date! !

!WADateSelector methodsFor: 'testing' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day
	^day! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
day: anObject
	^day := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear := anInteger! !

!WADateSelector methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	startYear := Date today year - 1.
	endYear := Date today year + 5.
	self date: self dateClass today! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month
	^month! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:01'!
month: anObject
	^month := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'private' stamp: 'jf 12/18/2009 10:29'!
privateIsValidDay: theDay monthNumber: theMonth year: theYear
	| daysInMonth |
	(theMonth between: 1 and: 12) ifFalse: [^false].
	daysInMonth := Date daysInMonth: (Date nameOfMonth: theMonth) forYear: theYear.
	^(theDay between: 1 and: daysInMonth)! !

!WADateSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: self months;
		on: #month of: self;
		labels: [ :each | self labelForMonth: each ].

	html select
		list: self days;
		on: #day of: self;
		labels: [ :each | self labelForDay: each ].

	html select
		list: self yearRange;
		on: #year of: self;
		labels: [ :each | self labelForYear: each ].

	self dateIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WADateSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:00'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid date'! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear := anInteger! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year
	^year! !

!WADateSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:02'!
year: anObject
	^year := anObject! !

!WADateSelector methodsFor: 'accessing' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

WACanvasWidget subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WADateTable commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADateTable renders a table containing dates from startDate to endDate. The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month (1-31) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells are empty.

Basically this is an abstract superclass for WASelectionDateTable

Instance Variables:
	datesCache	<(SequenceableCollection of: Date>	contains a date object for each date in the range startDate-endDate
	endDate	<Date>	end date of the range displayed in the table
	rows	<SequenceableCollection>	labels of the rows
	startDate	<Date>	start date of the range displayed in the table

!

!WADateTable methodsFor: 'enumerating' stamp: 'lr 10/28/2007 14:42'!
datesDo: aBlock separatedBy: monthlyBlock
	| month |
	month := datesCache first monthIndex.
	datesCache do: [ :date |
		date monthIndex = month ifFalse: [month := date monthIndex. monthlyBlock value].
		aBlock value: date ].
	monthlyBlock value! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endDate: aDate
	endDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'enumerating' stamp: 'pmm 5/16/2007 17:50'!
monthsAndLengthsDo: aTwoArgumentBlock
	| count last |
	count := 0.
	last := nil.
	self
		datesDo: [ :each |
			count := count + 1.
			last := each ]
		separatedBy: [
			aTwoArgumentBlock value: last month value: count.
			count := 0 ]! !

!WADateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 2/23/2008 18:25'!
renderContentOn: html
	html table
		class: 'DateTable';
		border: 1;
		with: [
			html tableRow: [
				self renderMonthHeadingsOn: html ].
			html tableRow: [
				self renderDayHeadingsOn: html ].
			rows keysAndValuesDo: [ :index :each | 
				html tableRow: [
					self
						renderRow: each
						index: index
						on: html ] ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:19'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date |
			html tableHeading
				class: 'DayHeading';
				with: date dayOfMonth ]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:20'!
renderHeadingForRow: anObject on: html
	html tableHeading
		class: 'RowHeading';
		with: anObject! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 12/18/2007 20:35'!
renderHeadingSpacerOn: html
	html tableData: ''! !

!WADateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:21'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo: [ :month :length |
		self renderHeadingSpacerOn: html.
		html tableHeading
			colSpan: length;
			class: 'MonthHeading';
			with: [
				html text: month name.
				html space.
				html text: month year ] ]! !

!WADateTable methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [ :date | self renderCellForDate: date row: anObject index: aNumber on: html]
		separatedBy: [ self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows := aCollection! !

!WADateTable methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startDate: aDate
	startDate := aDate.
	self updateDatesCache! !

!WADateTable methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].

	datesCache := OrderedCollection new.
	date := startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date := date next]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WASelectionDateTable commentStamp: 'rew 1/23/2008 21:13' prior: 0!
WASelectionDateTable renders a table containing dates and rows. A user can select a continuous block of cells in the table.  The table contains one column for each date from startDate to endDate. The top row of the table groups columns by month and labels each month (January 2008). The second row contains the date of each month  (1-30) in the date range. The table also contains "rows size" rows. The first column of these rows contains the contents of the instance variable "rows". Rest of the cells contents are given by "cellBlock". 

Instance Variables:
	cellBlock	<BlockClosure [:rowIndex :date | ]>	returns text for the cell in row "rowIndex" and column for "date"
	dateSelectionEnd	<Date>	last selected date
	dateSelectionStart	<Date>	first selected date
	rowSelectionEnd	<Integer>	index of last selected row
	rowSelectionStart	<Integer>	index of first selected row

!

!WASelectionDateTable methodsFor: 'selecting' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart := dateSelectionEnd := rowSelectionStart := rowSelectionEnd := nil! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
endDateSelection
	^ dateSelectionStart isNil
		ifFalse: [ dateSelectionStart max: dateSelectionEnd ]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
endRowSelection
	^ rowSelectionStart isNil
		ifFalse: [ rows at: (rowSelectionStart max: rowSelectionEnd) ]! !

!WASelectionDateTable methodsFor: 'testing' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'pmm 10/11/2006 19:27'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	| text |
	html tableData
		style: 'background-color: ', (self colorForDate: aDate rowIndex: aNumber);
		align: 'center';
		with: [
			text := cellBlock value: anObject value: aDate.
			html anchor callback: [self selectDate: aDate rowIndex: aNumber]; with: text ]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock := aBlock! !

!WASelectionDateTable methodsFor: 'editor access' stamp: 'lr 10/28/2007 14:42'!
selectAll
	dateSelectionStart := startDate.
	dateSelectionEnd := endDate.
	rowSelectionStart := 1.
	rowSelectionEnd := rows size! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart := dateSelectionEnd := aDate. rowSelectionStart := rowSelectionEnd := rowIndex]
		ifTrue: [dateSelectionEnd := aDate. rowSelectionEnd := rowIndex]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'accessing' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
startDateSelection
	^ dateSelectionStart isNil
		ifFalse: [ dateSelectionStart min: dateSelectionEnd ]! !

!WASelectionDateTable methodsFor: 'private' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'private' stamp: 'lr 2/28/2009 22:41'!
startRowSelection
	^ rowSelectionStart isNil
		ifFalse: [ rows at: (rowSelectionStart min: rowSelectionEnd) ]! !

!WASelectionDateTable methodsFor: 'rendering' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

WACanvasWidget subclass: #WADateTimeSelector
	instanceVariableNames: 'dateSelector timeSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WADateTimeSelector commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADateTimeSelector allows the user to select a date and time in a given range dropdown menus (html select). Actual work done by WADateSelector and WATimeSelector. Date range is default range of WADateSelector.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	dateSelector	<WADateSelector>	presents date selection to user
	timeSelector	<WATimeSelector>	presents time selection to user

!

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:19'!
children

	^ Array with: dateSelector with: timeSelector! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'jlr 4/5/2006 00:22'!
dateAndTime

	^ DateAndTime date: dateSelector date time: timeSelector time! !

!WADateTimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
dateAndTime: anObject

	dateSelector date: anObject asDate.
	timeSelector time: anObject asTime! !

!WADateTimeSelector methodsFor: 'initialization' stamp: 'lr 10/28/2007 14:42'!
initialize
	super initialize.
	dateSelector := WADateSelector new.
	timeSelector := WATimeSelector new! !

!WADateTimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html

	html span: dateSelector.
	html span: [html strong: ' : '].
	html span: timeSelector! !

WACanvasWidget subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAFormDialog commentStamp: 'rew 9/24/2007 20:23' prior: 0!
WAFormDialog is an empty html form. Used in WAComponent>>inform: to create a dialog component that displays text and an "Ok" button to close the component. See subclasses for sample usage & more functionality.

Instance Variables:
	form	<WAFormDecoration> Decorator that generates form tags
	validationError	<String>	Text descriping invalid data entered by user. Displayed when not nil. Set to nil when user submits form.
!

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAChoiceDialog commentStamp: 'pmm 9/25/2007 20:24' prior: 0!
WAChoiceDialog produces a form with select tag (dropdown menu) on a collection of options and "Ok" and "Cancel" buttons. Options can be any object. Returns actual object selected or nil if user select "Cancel". WAChoiceDialog is used to implement the chooseFrom:caption: convenience method in WAComponent.

	| selection |
	selection := WAChoiceDialog options: #('Smalltalk' 'Perl' 'Python' 'Ruby' 9).
	result := self call: selection.
	self inform: result printString

Instance Variables:
	options	<Collection of Objects> objects in list
	selection	<Object>	object selected by user or nil if user cancels

!

!WAChoiceDialog class methodsFor: 'examples' stamp: 'lr 8/3/2009 19:25'!
example
	^ self options: #('Perl' 'Python' 'Ruby' 'Smalltalk') selection: 'Smalltalk'! !

!WAChoiceDialog class methodsFor: 'instance creation' stamp: 'lr 8/3/2009 19:24'!
options: aCollection
	^ self options: aCollection selection: nil! !

!WAChoiceDialog class methodsFor: 'instance creation' stamp: 'lr 8/3/2009 19:24'!
options: aCollection selection: anObject
	^ self new
		options: aCollection;
		selection: anObject;
		yourself
		! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'actions' stamp: 'lr 8/3/2009 19:22'!
ok
	self answer: self selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options := aCollection! !

!WAChoiceDialog methodsFor: 'rendering' stamp: 'lr 8/3/2009 19:22'!
renderContentOn: html
	html select
		list: self options;
		selected: self selection;
		callback: [ :value | self selection: value ]! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'lr 8/3/2009 19:22'!
selection
	^ selection! !

!WAChoiceDialog methodsFor: 'accessing' stamp: 'lr 8/3/2009 19:22'!
selection: anObject
	selection := anObject! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/16/2004 13:45'!
addForm
	form := WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'accessing' stamp: 'mb 4/4/2006 13:41'!
defaultButton
	^self buttons first! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'initialization' stamp: 'pmm 11/2/2005 22:51'!
initialize
	super initialize.
	self addFormByDefault ifTrue: [self addForm]! !

!WAFormDialog methodsFor: 'testing' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

!WAFormDialog methodsFor: 'accessing' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'actions' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'actions' stamp: 'lr 2/28/2009 22:45'!
removeForm
	form isNil
		ifFalse: [ self removeDecoration: form ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 2/28/2009 22:45'!
renderContentOn: html
	html hiddenInput 
		callback: [ validationError := nil ].
	validationError isNil
		ifFalse: [ self renderValidationError: validationError on: html ].
	html div
		class: self divClass;
		with: [ self renderDialogOn: html ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:55'!
renderSpacerRowOn: html
	html div class: 'dialog-spacer'; with: [ html space ]! !

!WAFormDialog methodsFor: 'rendering' stamp: 'lr 1/7/2007 17:56'!
renderValidationError: aString on: html
	html span class: 'dialog-validation'; with: aString! !

!WAFormDialog methodsFor: 'validation' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError := aString! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WALabelledFormDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WALabelledFormDialog is an abstract class for generating html forms. Given a data model WALabelledFormDialog displays a label and input field for each instance variable of interest. User supplied data is placed in the data model.

Subclasses need to implment the methods labelForSelector:, model, and rows. The "model" method just returns the object whose fields we wish to populate with date. The "rows" method returns a collections of symbols. One symbol for each row of data in the dialog. The symbol is used generate the accessor methods for the data in the model. The method "labelForSelector:" returns the labels for each row and each submit button in the form.

A standard text input field is used for each row of data. To use other html widgets for input for = a datum implement the method renderXXXOn: where XXX is the symbol for the row. See "renderNameOn:" in example below.

The default form has one button "Ok". Override the "buttons" method to change the text or number of submit buttons on the form. Override the "defaultButton" method to indicate which button is the default. For each button in the form the subclass needs a method with the same name as the button, which is called when the user clicks that button. See example below.

LabelledFormDialogExample subclass of WALabelledFormDialog instance methods
	initialize
		super initialize.
		contact := Contact new. "contact is an inst var"
		self addMessage: 'Please enter the followning information'.

	model
		^ contact

	ok
		self answer: contact

	cancel
		self answer

	rows
		^ #(name phoneNumber)

	buttons
		#(ok cancel)

	labelForSelector: aSymbol
		aSymbol == #name ifTrue: [^'Your Name'].
		aSymbol == #phoneNumber ifTrue: [^'Phone Number'].
		aSymbol == #ok ifTrue: [^'Ok'].
		aSymbol == #cancel ifTrue: [^'Cancel'].
		^ super labelForSelector: aSymbol

	renderNameOn: html 
		"Show how to specily special input instead of using simple text field."
		(html select)
				list: #('Roger' 'Pete');
				selected: 'Roger';
				callback: [:v | contact name: v]

Contact Class used above has instance variables name, phoneNumber with standard getter and setter methods
!

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'al 9/7/2006 16:08'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInput
		on: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderRowForSelector: aSymbol on: html
	html div
		id: 'dialog-row-' , aSymbol;
		class: 'dialog-row';
		with: [
			html span
				class: 'dialog-form-label';
				with: [self renderLabelForSelector: aSymbol on: html].
			html span
				class: 'dialog-form-field';
				with: [self renderFieldForSelector: aSymbol on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]]! !

!WALabelledFormDialog methodsFor: 'rendering' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

!WALabelledFormDialog methodsFor: 'accessing' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAYesOrNoDialog commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WAYesOrNoDialog displays a yes/no dialog. Returns boolean indicating user selection. See WAComponent>>confirm: for sample usage and easy way to use WAYesOrNoDialog.!

!WAYesOrNoDialog class methodsFor: 'examples' stamp: 'lr 8/3/2009 19:26'!
example
	^ self new! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'accessing' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

WACanvasWidget subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAInputDialog commentStamp: 'rew 9/24/2007 20:24' prior: 0!
WAInputDialog generates a simple form with a text input field and a submit button. The instance variable "value" is used for initial value of the text field and hold the text entered by user. WAInputDialog answers with text entered by user (value of "value"). See WAComponent>>request:label:default: for sample use and easy way to use WAInputDialog.

Instance Variables:
	label	<String>	label of submit button
	value	<Object | String>	
!

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
default: aString
	value := aString! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
label
	^label ifNil: [ label := 'OK' ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:32'!
label: aString
	label := aString! !

!WAInputDialog methodsFor: 'rendering' stamp: 'pmm 8/31/2008 15:21'!
renderContentOn: html
	html form
		defaultAction: [ self answer: value ];
		with: [
			html div: [
				html textInput on: #value of: self.
				html space.
				html submitButton
					callback: [ self answer: value ];
					text: self label ] ]! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value
	^value! !

!WAInputDialog methodsFor: 'accessing' stamp: 'pmm 9/12/2006 18:34'!
value: aString
	value := aString! !

WACanvasWidget subclass: #WAMiniCalendar
	instanceVariableNames: 'monthIndex year date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAMiniCalendar commentStamp: '<historical>' prior: 0!
WAMiniCalendar renders a monthly calendar. Users can navigate by month, year, or select a year and a month. Users can select a date in the calendar. Set canSelectBlock to control which dates a user can select. Use selectBlock to perform an action when a user selects a date. WAMiniCalendar>>date returns the selected date.

Select "Mini Calendar" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	canSelectBlock		<BlockClosure with date argument>	return true if date argument should be rendered with a link, ie user can select that date
	date		<WAValueHolder on a date>	Selected date
	monthIndex		<WAValueHolder on an Integer>	Currently displayed month
	year		<WAValueHolder on an Integer>	Currently displayed year
	selectBlock		<BlockClosure with date argument> called when user selects a date

!

!WAMiniCalendar class methodsFor: 'testing' stamp: 'dc 12/28/2005 14:20'!
canBeRoot
	^ true! !

!WAMiniCalendar class methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:37'!
example
	^self new! !

!WAMiniCalendar methodsFor: 'testing' stamp: 'lr 12/28/2006 22:37'!
canSelect: aDate
	^ canSelectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:32'!
date: aDate 
	date contents: aDate.
	monthIndex contents: aDate monthIndex.
	year contents: aDate year! !

!WAMiniCalendar methodsFor: 'initialization' stamp: 'dkh 2/29/2008 09:32'!
initialize
	super initialize.
	monthIndex := WAValueHolder with: Date today monthIndex.
	year := WAValueHolder with: Date today year.
	date := WAValueHolder new.
	canSelectBlock := [:value | true].
	selectBlock := [:value | self answer: value]! !

!WAMiniCalendar methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
monthHeading
	^ self monthName , ' ' , self year greaseString! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:34'!
monthIndex
	^ monthIndex contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:34'!
monthIndex: anInteger 
	monthIndex contents: anInteger! !

!WAMiniCalendar methodsFor: 'private' stamp: 'dkh 2/29/2008 09:34'!
monthName
	^ Date nameOfMonth: self monthIndex! !

!WAMiniCalendar methodsFor: 'localization' stamp: 'dkh 2/29/2008 09:34'!
monthNames
	^ (1 to: 12)
		collect: [:each | Date nameOfMonth: each]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'obi 3/23/2008 10:34'!
nextMonth
	self monthIndex = 12
		ifTrue: [ self monthIndex: 1; year: self year + 1]
		ifFalse: [ self monthIndex: self monthIndex + 1 ]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'obi 3/23/2008 10:34'!
previousMonth
	self monthIndex = 1
		ifTrue: [ self monthIndex: 12; year: self year - 1]
		ifFalse: [ self monthIndex: self monthIndex - 1 ]
! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:30'!
renderCellForDate: aDate on: html
	html tableData: [
		(aDate monthIndex = self monthIndex and: [ aDate year = self year ])
			ifTrue: [
				html span
					class: (self date = aDate ifTrue: [ 'calendarArchiveDate' ]);
					with: [
						(self canSelect: aDate) 
							ifTrue: [
								html anchor
									callback: [ self select: aDate ];
									with: aDate dayOfMonth ]
							ifFalse: [ html text: aDate dayOfMonth ] ] ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:10'!
renderContentOn: html
	html div
		class: 'calendar';
		with: [
			html div
				class: 'calendarCaption';
				with: [ self renderMonthHeadingOn: html ].
			html table: [
				html tableRow
					class: 'calendarTitle';
					with: [
						self weekDays do: [ :each |
							html tableData: each ] ].
						self weeksDo: [ :week |
							self renderRowForWeek: week on: html ] ].
			self renderMonthNavigationOn: html.
			html
				space;
				space.
			self renderYearNavigationOn: html ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:13'!
renderMonthHeadingOn: html
	html form: [
		html div: [
			html select
				list: (1 to: 12);
				on: #monthIndex of: self;
				labels: [ :index | Date nameOfMonth: index ].
			html textInput
				maxLength: 4;
				on: #year of: self.
			html submitButton text: 'Refresh' ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:12'!
renderMonthNavigationOn: html
	| tab |
	tab := #(12 1 2 3 4 5 6 7 8 9 10 11 12 1).
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [ self previousMonth ];
				with: ((self monthNames at: (tab at: self monthIndex)) first: 3)].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [ self nextMonth ];
				with: ((self monthNames at: (tab at: self monthIndex + 2)) first: 3)].! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:26'!
renderRowForWeek: initialDay on: html
	html tableRow: [
		0 to: 6 do: [ :each |
			self renderCellForDate: (initialDay addDays: each) on: html ] ]! !

!WAMiniCalendar methodsFor: 'rendering' stamp: 'pmm 9/13/2008 14:25'!
renderYearNavigationOn: html
	html span
		class: 'calendarPrevious';
		with: [
			html anchor
				callback: [ self year: self year - 1 ];
				with: self year - 1 ].
	html space.
	html span
		class: 'calendarNext';
		with: [
			html anchor
				callback: [ self year: self year + 1 ];
				with: self year + 1 ]! !

!WAMiniCalendar methodsFor: 'action' stamp: 'lr 12/28/2006 22:38'!
select: aDate
	self date: aDate.
	selectBlock value: aDate! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WAMiniCalendar methodsFor: 'accessing' stamp: 'dkh 2/29/2008 09:37'!
states
	^Array with: date with: monthIndex with: year! !

!WAMiniCalendar methodsFor: 'private' stamp: 'jf 2/6/2010 00:44'!
weekDays
	^ #(Sun Mon Tue Wed Thu Fri Sat)! !

!WAMiniCalendar methodsFor: 'private' stamp: 'obi 5/22/2010 21:33'!
weeksDo: aBlock
	| day nextMonth |
	day := Date newDay: 1 month: (Date nameOfMonth: self monthIndex) year: self year.
	day := day subtractDays: (day dayOfWeek - 1).
	nextMonth := (self monthIndex \\ 12) + 1.
	[ day monthIndex = nextMonth ] whileFalse: [
		aBlock value: day.
		day := day addDays: 7 ]! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'dkh 2/29/2008 09:38'!
year
	^year contents! !

!WAMiniCalendar methodsFor: 'accessing-delegated' stamp: 'jf 9/30/2009 01:04'!
year: anIntegerOrString 
	year contents: (anIntegerOrString greaseInteger ifNil: [ 1900 ])! !

WACanvasWidget subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WANavigation methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:20'!
initialize
	super initialize.
	selection := WAValueHolder new! !

!WANavigation methodsFor: 'query' stamp: 'jf 9/30/2009 01:10'!
labelForOption: anObject 
	^ anObject greaseString! !

!WANavigation methodsFor: 'accessing' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 6/6/2007 17:49'!
renderContentOn: html
	html div class: 'kalsey'; with: [
		html div
			class: 'navigation-options';
			with: [ self renderOptionsOn: html ].
		html div
			class: 'navigation-content';
			with: [ self renderSelectionOn: html ] ]! !

!WANavigation methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderOptionsOn: html
	html unorderedList
		list: self options;
		selected: self selection;
		callback: [ :value | self select: value ];
		labels: [ :each | self labelForOption: each ]! !

!WANavigation methodsFor: 'rendering' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'selection' stamp: 'lr 6/6/2007 17:54'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'selection' stamp: 'lr 10/28/2007 14:42'!
selectionChanged! !

!WANavigation methodsFor: 'selection' stamp: 'lr 4/15/2007 19:57'!
states
	^ Array with: selection! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WASimpleNavigation commentStamp: 'jf 1/11/2009 19:15' prior: 0!
I'm a simple tab panel, that can be styled with stylesheets. New tabs can be added using #add:label:

You may want to add the WANavigationFiles library to your application for some default CSS styling.!

!WASimpleNavigation methodsFor: 'behavior' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
children
	^ Array with: self selectedComponent! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'pmm 12/7/2008 09:36'!
components
	^ components! !

!WASimpleNavigation methodsFor: 'initialize' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components := OrderedCollection new! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 11/29/2004 16:28'!
labels
	"Return the tabs labels"

	^ self options! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
options
	^ components collect: [ :each | each key ]! !

!WASimpleNavigation methodsFor: 'rendering' stamp: 'sd 11/28/2004 21:15'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'behavior' stamp: 'dkh 11/19/2009 11:34'!
selectFirst
	"Selects the first added component as active."
	
	components notEmpty
		ifTrue: [ self select: components first key ]! !

!WASimpleNavigation methodsFor: 'accessing' stamp: 'lr 6/6/2007 17:53'!
selectedComponent
	^ (components detect: [ :each | each key = self selection ] ifNone: [ ^ nil ]) value! !

WACanvasWidget subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WANavigationBar commentStamp: 'rew 2/14/2008 10:17' prior: 0!
WANavigationBar provides navigation links for a component, the WANavigationBar's owner. WANavigationBar is vertical in that all items in the bar are rendered in a column. WANavigationBar's owner typically is a top level component that renders a number of children components, including the WANavigationBar. When a user selects an item in the WANavigationBar a message is sent to the owner, so it can change.

The owner component needs to implement the method indicated by the instance variable "actionsSelector", the default value is "actions". This method returns a collections of symbols. The symbols become the list of items in the navigation bar. The first letter of the symbol is capitalized when displayed. If the symbol represents a 0-argument method it is rendered as a link. When the user clicks on the link the original symbol is send as a message to the owner component. If the symbol represents a 1-argument method it is rendered as a label followed by a text input box. The user has to know that they hit enter after filling the text box.

Instance Variables:
	actionsSelector	<ByteSymbol>	Symbol sent to owner to get a list of items to be listed in the navigation bar. Default value is "actions".
	owner	<WAComponent>	This is the navigation bar for the component "owner".!

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'accessing' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector := aSymbol! !

!WANavigationBar methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:27'!
initialize
	super initialize.
	actionsSelector := #actions! !

!WANavigationBar methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
owner: anObject
	owner := anObject! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:32'!
renderContentOn: html
	self actions do: [ :symbol |
		symbol numArgs = 0
			ifTrue: [ self renderLink: symbol on: html ]
			ifFalse: [ self renderInput: symbol on: html ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderInput: aSymbol on: html
	html form: [
		html strong: aSymbol capitalized.
		html space.
		html textInput
			callback: [ :value |
				self target perform: aSymbol with: value ] ]! !

!WANavigationBar methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:34'!
renderLink: aSymbol on: html
	html anchor
		on: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:31'!
target
	^ owner activeComponent! !

WACanvasWidget subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAPath commentStamp: 'rew 1/23/2008 21:12' prior: 0!
WAPath represents a path navigation (breadcrumbs) for a web page and displays standard breadcrumbs(xxx >> yyy >> zzz). WAPath maintains a stack of associations, one for each "location" or "page" in the path. The association key is the text that is displayed in the breadcrimb. The association value is an object of your choosing, which your code uses to restore that "page". 

To add to the path use the method WAPath>>pushSegment: anObject name: 'lulu'. The name: arguement is the association key, the segment: argument is the association value.

The method WAPath>>currentSegment returns object associated with the current "page". Your code is not notified when the user clicks on a link in the WAPath object. So when you render a page call WAPath>>currentSegment to get the current object, and generate the page accordingly.

See WAInspector for example use.

Use WATrail to handle breadcrumbs for sequences of call: and answers:.

Instance Variables:
	stack	<Array of associations(String->Object) > History of the page. Keys -> display string, values -> object used in helping generating page.

!

!WAPath class methodsFor: 'example' stamp: 'lr 10/28/2007 14:42'!
example
	^self new
		pushSegment: 123 name: 'xxx';
		pushSegment: 456 name: 'yyy';
		pushSegment: 789 name: 'zzz';
		yourself! !

!WAPath methodsFor: 'behavior' stamp: 'lr 2/4/2009 08:02'!
choose: anAssociation 
	"Install a new stack of navigation from the old one and the specified association."
	| newStack |
	newStack := WriteStream on: Array new.
	stack do: 
		[ :ea | 
		newStack nextPut: ea.
		ea == anAssociation ifTrue: 
			[ stack := newStack contents.
			^ self ] ]! !

!WAPath methodsFor: 'accessing' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'initialization' stamp: 'lr 4/15/2007 19:55'!
initialize
	super initialize.
	stack := #()! !

!WAPath methodsFor: 'behavior' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack := stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'rendering' stamp: 'lr 3/4/2009 12:19'!
renderContentOn: html
	stack isEmpty 
		ifTrue: [ ^ self ].
	html div class: 'path'; with: [
		stack allButLast do: [ :assoc |
			html anchor 
				callback: [ self choose: assoc ]; 
				with: assoc key.
			html text: ' >> '].
		html strong: stack last key ]! !

!WAPath methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: self! !

WACanvasWidget subclass: #WASelection
	instanceVariableNames: 'items labelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WASelection commentStamp: 'rew 9/24/2007 20:25' prior: 0!
WASelection creates a selectable list. Items can be any object. If optional labelBlock is not given the string versions of the items are displayed to user, otherwise labelBlock is used to generate the text to display for each item. Returns the item selected by user, (not the index nor the text shown the user). 

	| selection |
	selection := WASelection new.
	selection items: #(1 'cat' 'rat').
	selection 
		labelBlock: [:item | item = 1 ifTrue: ['First'] ifFalse: [item asUppercase]].
	result := self call: selection.
	self inform: result printString

Instance Variables:
	items	<Array of Objects> 	
	labelBlock	<One arg Block>	

!

!WASelection methodsFor: 'initialization' stamp: 'jf 9/30/2009 01:10'!
initialize
	super initialize.
	items := #().
	labelBlock := [ :each | each greaseString ]! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:04'!
items
	^ items! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
items: aCollection
	items := aCollection! !

!WASelection methodsFor: 'accessing' stamp: 'lr 1/7/2007 18:06'!
labelBlock
	^ labelBlock! !

!WASelection methodsFor: 'accessing' stamp: 'avi 7/5/2004 20:24'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WASelection methodsFor: 'rendering' stamp: 'lr 1/7/2007 18:05'!
renderContentOn: html
	html unorderedList
		list: self items;
		labels: self labelBlock;
		callback: [ :value | self answer: value ]! !

WACanvasWidget subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WATableReport commentStamp: 'rew 2/14/2008 10:16' prior: 0!
WATableReport presents tabular data. A WATableReport contains a collections of objects, one per row, and a collection of WAReportColumns. The WAReportColumn objects are configured to produce the text for the table cell based on the each row object. Each column has a header and an optional column sum. The table can be sorted on a column by clicking its header, unless the column handles rendering on the canvas itself. A table can be given a set of html colors (rowColors), used to colors the rows to aid in viewing. 

For more information see:
	Example - WATableReportTestm (initialization code below)
	WATableReport Tutorial - http://www.cdshaffer.com/david/Seaside/WATableReport/index.html

Instance Variables:
	columns	<Collection of WAReportColumn>	Each WAReportColumn produces the text for each table cell in a column  
	isReversed	<Boolean>	true if the current sort column is to be sorted in reverse order
	rowColors	<Collection of String/Symbol>	Each element is a string for an html color, which is used as a background color for table rows
	rowPeriod	<Integer>	Each color in rowColors is used for rowPeriod consectutive rows before using the next row color.
	rows	<Collection of Object>	Each element of the collection provides the data for a row in the table.
	sortColumn	<WAValueHolder on WAReportColumn>	Column used to sort the the table rows

Example:
	WATableReport new
		rows: WAComponent allSubclasses asArray;
		columns: (OrderedCollection new
			add: (WAReportColumn
				selector: #fullName title: 'Name'
				onClick: [ :each | self inform: each description ]);
			add: ((WAReportColumn
				selector: #canBeRoot title: 'Can Be Root')
				sortBlock: [ :a :b | a ]);
			add: (WAReportColumn
				renderBlock: [ :each :html | html emphasis: each description ]
				title: 'Description');
			yourself);
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself!

!WATableReport methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
chooseRow: aRow column: aColumn
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'private' stamp: 'lr 2/20/2009 22:12'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber - 1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: [ '#fff' ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns := anArray! !

!WATableReport methodsFor: 'initialization' stamp: 'lr 2/20/2009 22:13'!
initialize
	super initialize.
	isReversed := false.
	rows := #().
	columns := #().
	sortColumn := WAValueHolder new.
	rowColors := #('#fff' '#eee').
	rowPeriod := 1! !

!WATableReport methodsFor: 'testing' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'DanWinkler 9/25/2010 12:52'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		html tableData
			class: aColumn cssClass;
			with: [ aColumn renderValue: aRow on: html ].
		^ self ].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData
		class: aColumn cssClass;
		with: [
			aColumn canChoose
				ifFalse: [
					(aColumn anchorBlock) ifNil: [html text: text]
						ifNotNil: [html anchor url: (aColumn anchorForRow: aRow); with: text]]
				ifTrue: [
					html anchor
						callback: [ self chooseRow: aRow column: aColumn ];
						with: text ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 2/20/2009 22:08'!
renderContentOn: html
	html table: [
		html tableHead: [ self renderTableHeaderOn: html ].
		html tableFoot: [ self renderTableFooterOn: html ].
		html tableBody: [ self renderRowsOn: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 2/20/2009 22:10'!
renderFooterForColumn: aColumn on: html
	html tableData
		class: aColumn cssClass;
		with: (aColumn totalForRows: rows)! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 2/20/2009 22:09'!
renderHeaderForColumn: aColumn on: html
	html tableHeading
		class: aColumn cssClass;
		with: [
			aColumn canSort
				ifTrue: [
					html anchor
						callback: [self sortColumn: aColumn];
						with: aColumn title]
				ifFalse: [ html text: aColumn title ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:48'!
renderRowNumber: index item: row on: html
	html tableRow
		style: 'background-color: ' , (self colorForRowNumber: index);
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 2/20/2009 22:08'!
renderRowsOn: html 
	self rows keysAndValuesDo: [ :index :row | 
		self renderRowNumber: index item: row on: html ]! !

!WATableReport methodsFor: 'rendering' stamp: 'pmm 9/30/2006 20:38'!
renderTableFooterOn: html
	html tableRow: [
		columns do: [ :each |
			self renderFooterForColumn: each on: html] ]! !

!WATableReport methodsFor: 'rendering' stamp: 'lr 2/20/2009 22:06'!
renderTableHeaderOn: html
	html tableRow: [
		columns do: [ :each |
			self renderHeaderForColumn: each on: html ] ]! !

!WATableReport methodsFor: 'state variables' stamp: 'lr 2/20/2009 22:12'!
reverse
	isReversed := isReversed not! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors := colorArray! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod := aNumber! !

!WATableReport methodsFor: 'accessing' stamp: 'jok 4/22/2010 17:15'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r := self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reverse] ifFalse: [r]! !

!WATableReport methodsFor: 'accessing' stamp: 'rew 1/25/2008 20:34'!
rows: anArray
	rows := anArray! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'state variables' stamp: 'lr 2/20/2009 22:12'!
sortColumn: anObject
	isReversed := anObject = self sortColumn and: [ isReversed not ].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:51'!
states
	^ Array with: sortColumn! !

WACanvasWidget subclass: #WATimeSelector
	instanceVariableNames: 'second hour minute startHour endHour'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WATimeSelector commentStamp: 'rew 1/23/2008 21:14' prior: 0!
WATimeSelector displays dropdown menus (html select) allowing a user to delect a time within a range. "startHour" and "endHour" define the range of selectable times. Time is displayed in 24 hour format. WATimeSelector>>time returns time user selected as a Time object.

See WADateSelectorTest for sample of usage.
Select "Date Selector" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	endHour	<Integer 0-23>	end of time interval for selectable times
	hour	<Integer 0-23>	selected hour
	minute	<Integer 0-59>	selected minute
	second	<Integer 0-59>	selected second
	startHour	<Integer 0-23>	start of time interval for selectable times
!

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
date: aDate
	second := aDate dayOfMonth.
	hour := aDate monthIndex.
	minute := aDate year! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:37'!
days
	^ 1 to: 31! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
endHour
	^endHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
endHour: anInteger
	endHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour
	^hour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
hour: anObject
	^hour := anObject! !

!WATimeSelector methodsFor: 'initialization' stamp: 'mb 5/6/2006 16:10'!
initialize
	super initialize.
	startHour := 0.
	endHour := 23.
	self time: Time midnight! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute
	^minute! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
minute: anObject
	^minute := anObject! !

!WATimeSelector methodsFor: 'private' stamp: 'lr 2/12/2008 08:10'!
privateIsValidSecond: theSecond hourNumber: theHour minuteNumber: theMinute

	^ (theHour between: 0 and: 23)
		and: [ (theMinute between: 0 and: 59)
		and: [ theSecond between: 0 and: 59 ] ]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	html select
		list: (0 to: 23);
		on: #hour of: self.
	html  select
		list: (0 to: 59);
		on: #minute of: self.
	html  select
		list: (0 to: 59);
		on: #second of: self.

	self timeIsValid ifFalse: [self renderValidationErrorOn: html]! !

!WATimeSelector methodsFor: 'rendering' stamp: 'pmm 10/11/2006 18:23'!
renderValidationErrorOn: html
	html span
		class: 'error';
		with: 'invalid time'! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second
	^second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'pmm 10/11/2006 18:10'!
second: anObject
	^second := anObject! !

!WATimeSelector methodsFor: 'accessing' stamp: 'jlr 4/4/2006 23:48'!
startHour
	^startHour! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
startHour: anInteger
	startHour := anInteger! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time
	(self
		privateIsValidSecond: second
		hourNumber: hour
		minuteNumber: minute) ifFalse: [self error: 'Invalid time'].
	^self timeClass
		hour: hour
		minute: minute
		second: second! !

!WATimeSelector methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
time: aTime
	second := aTime second.
	hour := aTime hour.
	minute := aTime minute! !

!WATimeSelector methodsFor: 'private' stamp: 'pmm 10/22/2006 07:22'!
timeClass
	^Time! !

!WATimeSelector methodsFor: 'testing' stamp: 'jlr 4/4/2006 23:46'!
timeIsValid
	[self time] on: Error do: [:e | ^ false].
	^ true! !

WACanvasWidget subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WATrail commentStamp: 'rew 1/25/2008 20:49' prior: 0!
WATrail implements breadcrumbs for pages generated using a sequence of WAComponent>>call: methods. Each component in the call sequence that is to appear in the breadcrumb must implement the method "trailName", which returns the text displayed in the breadcrumb. 

Instantiate (WATrail on: rootComponent) an WATrail object on the first component (root) of the breadcrumb. When the root component, or subsequent component, transfers control via "self call:" the WATrail object is automatically updated and will display the correct call sequence in the breadcrumb. When a user clicks on a link in the breadcrumb the call sequence is automatically updated.

The breadcrumb is placed in a div with class "trail" and each crumb is separated with the character '>', which is inside a span of class "separator" to aid in using CSS to format the breadcrumbs.

Instance Variables:
	root	<WAComponent>	first component in the breadcrumb and in the call sequence.

!

!WATrail class methodsFor: 'instance creation' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'rendering' stamp: 'dkh 11/19/2009 10:07'!
renderContentOn: html
	| last selected |
	last := nil.
	html div
		class: 'trail';
		with: [
			root visiblePresentersDo: [ :each | 
				(each isDecoration and: [ each isDelegation ]) ifTrue: [
					(each decoratedComponent respondsTo: #trailName) ifTrue: [
						last := each.
						html anchor
							callback: [ each remove ];
							with: (each decoratedComponent perform: #trailName).
						html span
							class: 'separator';
							with: self separator ] ] ].
			selected := last isNil
				ifTrue: [ root ]
				ifFalse: [ last delegate ].
			(selected respondsTo: #trailName) ifTrue: [
				html text: (selected perform: #trailName) ] ]! !

!WATrail methodsFor: 'accessing' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root := anObject! !

!WATrail methodsFor: 'accessing' stamp: 'rew 1/25/2008 20:50'!
separator
	
	^' > '! !

WACanvasWidget subclass: #WATree
	instanceVariableNames: 'root selected expanded childrenBlock labelBlock canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WATree commentStamp: 'rew 1/23/2008 21:14' prior: 0!
WATree implements a tree menu, which supports nesting, collapsing and expanding. Prefixes items with "+/-" to indicate items that can be expanded/collapsed.

See class methods for simple example.


Instance Variables:
	canSelectBlock	<BlockClosure [:nodeInTree | ]>	returns true if user can select the argument of the block, if true node is an anchor
	childrenBlock	<BlockClosure [:nodeInTree | ]>	returns children (or subnodes) of the given node in the tree, sent to all nodes
	expanded	<IdentitySet>	Collection of all nodes that are currently expanded
	labelBlock	<[:nodeInTree | ]> returns text to display for given node
	root	<Object>	root or top level node in tree, childrenBlock is used to determine roots subnodes
	selectBlock	<BlockClosure [:selectedNode | ]>	called when an node is selected, put a callback to your code here
	selected	<Object>	currently selected node


!

!WATree class methodsFor: 'examples' stamp: 'pmm 9/28/2008 12:30'!
exampleClassBrowser
	^ self new
		root: Collection;
		labelBlock: [ :class | class name ];
		childrenBlock: [ :class | class subclasses ];
		yourself! !

!WATree class methodsFor: 'instance creation' stamp: 'lr 3/27/2006 11:08'!
root: anObject
	^ self new
		root: anObject;
		yourself! !

!WATree class methodsFor: 'instance creation' stamp: 'lr 3/27/2006 11:09'!
root: anObject path: anArray
	^ (self root: anObject)
		expandAll: anArray;
		selected: anArray last;
		yourself! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canSelect: aNode
	^self selectBlock notNil
		and: [ self canSelectBlock isNil
			or: [ self canSelectBlock value: aNode ] ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 12:11'!
canSelectBlock
	^canSelectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 3/7/2005 17:40'!
canSelectBlock: aBlock
	canSelectBlock := aBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
childrenBlock
	^childrenBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
childrenBlock: aBlock
	childrenBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 3/27/2006 09:12'!
childrenOf: aNode
	| children |
	children := self childrenBlock value: aNode.
	^ children ifNil: [ Array new ]! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
collapse: aNode
	expanded remove: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expand: aNode
	expanded add: aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
expandAll: aCollection
	expanded addAll: aCollection! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
hasChildren: aNode
	^(self childrenOf: aNode)
		isEmpty not! !

!WATree methodsFor: 'initialization' stamp: 'jf 9/30/2009 01:10'!
initialize
	super initialize.
	expanded := IdentitySet new.
	self selectBlock: [ :node | self answer: node ].
	self childrenBlock: [ :node | Array new ].
	self labelBlock: [ :node | node greaseString ]! !

!WATree methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
isExpanded: aNode
	^expanded includes: aNode! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:19'!
labelBlock
	^labelBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:20'!
labelBlock: aBlock
	labelBlock := aBlock! !

!WATree methodsFor: 'accessing-nodes' stamp: 'lr 10/28/2007 14:42'!
labelOf: aNode
	^self labelBlock value: aNode! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderContentOn: html
	self renderTreeOn: html! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:27'!
renderNode: aNode on: html
	html listItem: [
		self renderNodeButton: aNode on: html.
		self renderNodeLabel: aNode on: html.
		self renderNodeChildren: aNode on: html ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'jf 9/30/2009 00:22'!
renderNodeButton: aNode on: html 
	| isExpanded |
	html span
		class: 'button';
		with: 
			[ (self hasChildren: aNode) ifTrue: 
				[ isExpanded := self isExpanded: aNode.
				self 
					renderNodeButtonLink: aNode
					action: (GRDelayedSend 
							receiver: self
							selector: (isExpanded 
									ifTrue: [ #collapse: ]
									ifFalse: [ #expand: ])
							argument: aNode)
					text: (isExpanded 
							ifTrue: [ '-' ]
							ifFalse: [ '+' ])
					on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:24'!
renderNodeButtonLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering-nodes' stamp: 'lr 10/28/2007 14:42'!
renderNodeChildren: aNode on: html
	| children |
	children := self childrenOf: aNode.
	children isEmpty ifFalse: [
		(self isExpanded: aNode) ifTrue: [
			html unorderedList: [
				children do: [ :each |
					self renderNode: each on: html ] ] ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'jf 9/30/2009 00:22'!
renderNodeLabel: aNode on: html 
	| label |
	html span
		class: 'label';
		class: (self selected == aNode 
				ifTrue: [ 'active' ]
				ifFalse: [ 'inactive' ]);
		with: 
			[ label := self labelOf: aNode.
			(self canSelect: aNode) 
				ifFalse: [ html render: label ]
				ifTrue: 
					[ self 
						renderNodeLabelLink: aNode
						action: (GRDelayedSend 
								receiver: self
								selector: #select:
								argument: aNode)
						text: label
						on: html ] ]! !

!WATree methodsFor: 'rendering-nodes' stamp: 'pmm 9/22/2006 23:28'!
renderNodeLabelLink: aNode action: aBlock text: anObject on: html
	html anchor callback: aBlock; with: anObject! !

!WATree methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:42'!
renderTreeOn: html
	html unorderedList: [ self renderNode: self root on: html ]! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root
	^root! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:18'!
root: aNode
	root := aNode! !

!WATree methodsFor: 'actions' stamp: 'lr 3/25/2008 22:13'!
select: aNode 
	(self canSelect: aNode) ifFalse: [ ^ self ].
	self selected: aNode.
	self selectBlock isNil ifFalse: [ self selectBlock value: aNode ]! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock
	^selectBlock! !

!WATree methodsFor: 'accessing-configuration' stamp: 'lr 2/19/2005 11:21'!
selectBlock: aBlock
	selectBlock := aBlock! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected
	^selected! !

!WATree methodsFor: 'accessing' stamp: 'lr 2/19/2005 11:19'!
selected: aNode
	selected := aNode! !

!WATree methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:56'!
states
	^ Array with: expanded! !

!WAComponent methodsFor: '*seaside-widgets-decorations' stamp: 'lr 8/3/2009 20:26'!
addMessage: aString
	"Add a decoration that displays a level 3 heading with aString around the receiver. Answer the decoration, so don't forget #yourself."
	
	^ self addDecoration: (WAMessageDecoration new message: aString; yourself)! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 8/3/2009 20:21'!
chooseFrom: aCollection caption: aString onAnswer: aBlock
	"Choose an item from the given aCollection with caption aString. Evaluate aBlock with the selected item."
	
	self chooseFrom: aCollection default: nil caption: aString onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'jf 12/19/2009 01:47'!
chooseFrom: aCollection default: anObject caption: aString onAnswer: aBlock
	"Choose an item from the given aCollection, the default anObject and the caption aString. Evaluate aBlock with the selected item."
	
	self 
		call: (WAChoiceDialog new
			addMessage: aString;
			options: aCollection;
			selection: anObject;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 8/3/2009 20:22'!
chooseFrom: aCollection default: anObject onAnswer: aBlock
	"Choose an item from the given aCollection and the default anObject. Evaluate aBlock with the selected item."
	
	self chooseFrom: aCollection default: anObject caption: nil onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 8/3/2009 20:22'!
chooseFrom: aCollection onAnswer: aBlock
	"Choose an item from the given aCollection. Evaluate aBlock with the selected item."

	self chooseFrom: aCollection default: nil caption: nil onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'jf 12/19/2009 01:47'!
confirm: aString onAnswer: aBlock
	"Display a yes/no dialog with caption aString. Evaluate aBlock passing in true if the response is yes, false if no."

	self
		call: (WAYesOrNoDialog new
			addMessage: aString;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'jf 12/19/2009 01:48'!
inform: aString	onAnswer: aBlock	
	"Display a dialog with aString to the user until he clicks the ok button. Continue by evaluating aBlock."

	self 
		call: (WAFormDialog new
			addMessage: aString;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 1/24/2009 20:58'!
request: aRequestString default: aDefaultString onAnswer: aBlock
	"Display an input dialog with the question aRequestString and the default string aDefaultString. Passes the answer into aBlock."

	self request: aRequestString label: nil default: aDefaultString onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'jf 12/19/2009 01:48'!
request: aRequestString label: aLabelString default: aDefaultString onAnswer: aBlock
	"Display an input dialog with the question aRequestString, the button label aLabelString and the default string aDefaultString. Passes the answer into aBlock."
	
	self
		call: (WAInputDialog new
			addMessage: aRequestString;
			default: aDefaultString;
			label: aLabelString;
			yourself)
		onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 1/24/2009 20:58'!
request: aRequestString label: aLabelString onAnswer: aBlock
	"Display an input dialog with the question aRequestString and the button label aLabelString. Passes the answer into aBlock."

	self request: aRequestString label: aLabelString default: nil onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-dialogs' stamp: 'lr 1/24/2009 20:54'!
request: aString onAnswer: aBlock
	"Display an input dialog with the question aRequestString. Passes the answer into aBlock."

	self request: aString default: nil onAnswer: aBlock! !

!WAComponent methodsFor: '*seaside-widgets-decorations' stamp: 'lr 8/3/2009 20:26'!
validateWith: aBlock
	^ self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

WADecoration subclass: #WAWidgetDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

WAWidgetDecoration subclass: #WADelayedAnswerDecoration
	instanceVariableNames: 'delay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WADelayedAnswerDecoration commentStamp: 'rew 1/23/2008 21:11' prior: 0!
WADelayedAnswerDecoration adds a delay in displaying a component. 

See WADelayTest for sample usage.
Select 'Delay" tab of the Functional Seaside Test Suite to run an example  (http://127.0.0.1:xxxx/seaside/tests/alltests)

Instance Variables:
	delay	<Integer>	delay length in seconds 

!

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'lr 5/23/2007 19:58'!
delay
	^ delay ifNil: [ 1 ]! !

!WADelayedAnswerDecoration methodsFor: 'accessing' stamp: 'avi 3/27/2005 20:34'!
delay: aNumber
	delay := aNumber! !

!WADelayedAnswerDecoration methodsFor: 'path' stamp: 'jf 2/15/2010 02:11'!
updateRoot: anHtmlRoot 
	| url |
	super updateRoot: anHtmlRoot.
	url := anHtmlRoot context actionUrl withField:
				(anHtmlRoot context callbacks store:
					(WAActionCallback on: [ self decoratedComponent answer ])).
	anHtmlRoot meta 
		redirectAfter: self delay
		to: url greaseString! !

WAWidgetDecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WAFormDecoration commentStamp: 'rew 9/13/2007 21:21' prior: 0!
A WAFormDecoration places its component inside an html form tag. The buttons inst var must be set. The component that a WAFormDecoration decorates must implement the method "defaultButton", which returns the string/symbol of the default button (one selected by default) of the form. Don't place any decorators between WAFormDecoration and its component otherwise "defaultButton" method fails. For each string/symbol in the buttons inst var the decorated component must implement a method of the same name, which is called when the button is selected.

Instance Variables
	buttons:		<Collection of strings or symbols>

buttons
	- list of strings or symbols, each string/symbol is the label (first letter capitalized) for a button and the name of the callback method on component when button is pressed, 
!

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'accessing' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons := selectorArray! !

!WAFormDecoration methodsFor: 'actions' stamp: 'jf 9/30/2009 18:20'!
defaultAction
	self decoratedComponent perform: self decoratedComponent defaultButton! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'jf 9/30/2009 18:30'!
renderButtonForSelector: aSymbol on: html
	html submitButton on: aSymbol of: self decoratedComponent! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'lr 9/25/2007 23:29'!
renderButtonsOn: html
	html div class: 'dialog-buttons'; with: [
		self buttons do: [ :each |
			html  span
				class: 'dialog-button-' , each;
				with: [ self renderButtonForSelector: each on: html ] ] ]! !

!WAFormDecoration methodsFor: 'rendering' stamp: 'jf 11/3/2008 22:28'!
renderContentOn: html
	html form
		defaultAction: [ self defaultAction ];
		with: [
			html div: [
				self renderNextOn: html.
				self renderButtonsOn: html ] ]! !

WAWidgetDecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WAMessageDecoration commentStamp: 'rew 9/13/2007 16:57' prior: 0!
I add a string message on top of the WAComponent I decorate. For example if change WACounter>>initialize as below the text "Counter Example" will appear on above the counter when rendered.

WACounter>>initialize
	super initialize.
	self count: 0.
	self addMessage: 'Counter Example'	"added line"

!

!WAMessageDecoration methodsFor: 'accessing' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message := aString! !

!WAMessageDecoration methodsFor: 'rendering' stamp: 'jf 11/3/2008 22:28'!
renderContentOn: html
	html heading level3; with: message.
	self renderNextOn: html! !

WAWidgetDecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock exceptionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WAValidationDecoration commentStamp: 'rew 9/13/2007 22:16' prior: 0!
A WAValidationDecoration validates its component form data when the component returns using "answer" or "answer:". A WAValidationDecoration can be added to component via the method "validateWith:" as below.

	SampleLoginComponent>>intialize
		form := WAFormDecoration new buttons: self buttons.
		self addDecoration: form.
		self validateWith: [:answerArgOrSelf | answerArgOrSelf validate].
		self addMessage: 'Please enter the following information'.

If component returns via "answer:" the answer: argument is passed to the validate block. If the component returns using "answer" the sender of "answer" is passed to the validate block.

Instance Variables
	exceptionClass:		<Notification>
	message:		<String>
	validationBlock:		<one arg block>

exceptionClass
	- Type of notication that is raised by validation code when validation fails. Default value is WAValidationNotification

message
	- String message displayed on validation failure. Obtained from the notification

validationBlock
	- One arg block, 
!

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 6/3/2006 22:40'!
exceptionClass
	^exceptionClass ifNil: [exceptionClass := WAValidationNotification]! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'cds 7/25/2005 10:19'!
exceptionClass: aClass
	exceptionClass := aClass! !

!WAValidationDecoration methodsFor: 'call/answer' stamp: 'pmm 11/2/2005 23:04'!
handleAnswer: anObject
	^(super handleAnswer: anObject)
		or: [(self validate: anObject) not]! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	(self validate: anObject) ifTrue: [aBlock value]! !

!WAValidationDecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	message := WAValueHolder new! !

!WAValidationDecoration methodsFor: 'rendering' stamp: 'jf 11/3/2008 22:27'!
renderContentOn: html
	message contents isNil ifFalse: [
		html div
			class: 'validation-error';
			with: message contents ].
	self renderNextOn: html! !

!WAValidationDecoration methodsFor: 'accessing' stamp: 'lr 4/15/2007 19:58'!
states
	^ Array with: message! !

!WAValidationDecoration methodsFor: 'request processing' stamp: 'jf 2/21/2009 10:00'!
validate: anObject
	^ [ validationBlock value: anObject.
	message contents: nil.
	true ]
		on: self exceptionClass
		do: [ :exception |
			message contents: exception messageText.
			exception return: false ]! !

!WAValidationDecoration methodsFor: 'convenience' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock := aBlock! !

!WAWidgetDecoration methodsFor: 'rendering' stamp: 'jf 9/4/2009 16:07'!
rendererClass
	"Make sure we use WARenderCanvas even if a different renderer is default."
	^ WARenderCanvas! !

WAWidgetDecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Decorations'!

!WAWindowDecoration commentStamp: 'pmm 10/3/2007 21:11' prior: 0!
WAWindowDecoration adds a simple title and close button in a bordered area at the top of the page. When closed button is selected nil is "answer"ed. Useful for a quick & dirty dialog window. Used by WAPlugin and SCTestRunner.

Instance Variables:
	cssClass	<String>	String added to "window-title " to generate cssClass for the title
	title	<String>	title of page
!

!WAWindowDecoration class methodsFor: 'instance creation' stamp: 'pmm 10/3/2007 21:12'!
title: aTitle
	^self new
		title: aTitle;
		yourself! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'lr 5/28/2007 17:52'!
cssClass: aString
	cssClass := aString! !

!WAWindowDecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'jf 9/30/2009 18:29'!
renderCloseButtonOn: html
	html anchor
		title: 'Close';
		callback: [ self decoratedComponent answer: nil ];
		with: [ html html: '&times;' ]! !

!WAWindowDecoration methodsFor: 'rendering' stamp: 'jf 11/3/2008 22:27'!
renderContentOn: html
	html div class: 'window'; with: [
		html div class: 'window-titlebar'; with: [
			html div class: 'window-title'; class: cssClass; with: title.
			html div class: 'window-close'; with: [ self renderCloseButtonOn: html ] ].
		html div class: 'window-content'; with: [ self renderNextOn: html ] ]! !

!WAWindowDecoration methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title := aString! !

WAObject subclass: #WAReportColumn
	instanceVariableNames: 'anchorBlock clickBlock formatBlock hasTotal title sortBlock valueBlock cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Widgets-Components'!

!WAReportColumn commentStamp: 'pmm 3/24/2008 16:44' prior: 0!
WAReportColumn displays a column, one cell at a time, of a WAReportTable. Columns can be sorted, have a title, can have a total, and its element can be links. The valueBlock obtains the output (an object) to display for each row from the row's object.  The formatBlock is used to convert the valueBlock output to a string. If you need html markup to display the result, use the two argument form of valueBlock. However, columns with two argument valueBlock can not be sorted. See class methods for shortcut methods for setting the value block. 

For more information see:
	WATableReport

Instance Variables:
	clickBlock	<BlockClosure [:rowObject | ]>	When clickBlock is set items in column will be anchors. clickBlock is called with the selected object when anchor is clicked on. Typically clickBlock calls a component which generates a new page.
	formatBlock	<BlockClosure [:object | ]>	Should convert the result of the one-argument valueBlock to the string to be displayed. If formatBlock is nil then  "displayString" is sent to the result of valueBlock for the display string for this column.  
	hasTotal	<Boolean>	If true the column will display the sum of all elements in the column, sum is displayed in the last row.
	sortBlock	<BlockClosure [:a :b | ]>	Used to sort the element in the column. Arguments are the value from the one argument valueBlock
	title	<String>	Column header 
	valueBlock	<BlockClosure [:rowObject | ] or [:rowObject :aWARenderCanvas |] >	
		[:rowObject | ] this form results in an object that is to be displayed in a column cell, argument is the object for a given row (see WATableReport)
		[:rowObject :aWARenderCanvas |] this form is to render the value for a column cell from rowObject directly on aWRenderCanvas
cssClass
	title <String> CSS class
	the CSS class assigned to the <td>-tag in this column 

!

!WAReportColumn class methodsFor: 'instance creation' stamp: 'mb 5/30/2006 12:13'!
renderBlock: aBlock title: aString
	^ self new
		title: aString;
		valueBlock: aBlock;
		yourself! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn class methodsFor: 'instance creation' stamp: 'pmm 4/19/2006 17:42'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock;
		yourself! !

!WAReportColumn methodsFor: 'accessing' stamp: 'DanWinkler 9/25/2010 12:44'!
anchorBlock
	^ anchorBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'DanWinkler 9/25/2010 12:44'!
anchorBlock: anObject
	anchorBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'DanWinkler 9/25/2010 12:53'!
anchorForRow: row
	^ anchorBlock value: row! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

!WAReportColumn methodsFor: 'rendering' stamp: 'pmm 1/10/2009 19:24'!
canRender
	^valueBlock argumentCount > 1! !

!WAReportColumn methodsFor: 'public' stamp: 'lr 10/28/2007 14:42'!
canSort
	^self canRender not and: [sortBlock notNil]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock := aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'pmm 3/24/2008 16:39'!
cssClass
	^ cssClass! !

!WAReportColumn methodsFor: 'accessing' stamp: 'pmm 3/24/2008 16:41'!
cssClass: aString
	cssClass := aString! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hasTotal: aBoolean
	hasTotal := aBoolean! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock := [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'initialization' stamp: 'DanWinkler 9/25/2010 12:46'!
initialize
	super initialize.
	formatBlock := [ :x | x greaseString ].
	sortBlock := [ :a :b | a <= b ].
	valueBlock := [ :row | nil ].
	clickBlock := nil.
	anchorBlock := nil.
	title := 'Untitled'.
	hasTotal := false! !

!WAReportColumn methodsFor: 'rendering' stamp: 'mb 5/30/2006 11:47'!
renderValue: anObject on: html
	valueBlock value: anObject value: html! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock := [:row | row perform: aSymbol]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs := anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs := assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'DanWinkler 9/25/2010 12:28'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title := aString! !

!WAReportColumn methodsFor: 'public' stamp: 'jf 12/16/2009 15:23'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [ formatBlock value: (aCollection inject: 0 into: [:sum :r | sum + (self valueForRow: r)])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'DanWinkler 9/25/2010 12:22'!
valueBlock: aBlock
	valueBlock := aBlock.
! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !
